## fis-gtm 6.0-003

=== debian/changelog ===
fis-gtm (6.0-003-2) unstable; urgency=medium

  * Make sure help files will be properly installed.  Thanks for the patch
    to Brad King <brad.king@kitware.com>

 -- Andreas Tille <tille@debian.org>  Fri, 20 Dec 2013 22:32:19 +0100

fis-gtm (6.0-003-1) unstable; urgency=low

  * Initial release (Closes: #541239)

 -- Andreas Tille <tille@debian.org>  Sun, 24 Nov 2013 09:26:25 +0100
