=== debian/watch ===
version=3
http://sf.net/fis-gtm/fis-gtm-V(\d[-.\d]+)\.tar\.gz
