## fis-gtm 6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #################################################################
 #								#
-#	Copyright 2012, 2013 Fidelity Information Services, Inc	#
+#	Copyright 2012, 2014 Fidelity Information Services, Inc	#
 #								#
 #	This source code contains the intellectual property	#
 #	of its copyright holder(s), and is made available	#
@@ -26,7 +26,7 @@
 endforeach()
 
 # Defaults
-set(version V6.0-003)
+set(version V6.2-002A)
 if("${version}" STREQUAL "")
         set(version V9.9-0)
 endif()
@@ -36,8 +36,17 @@
   set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
 endif()
 
-# If it's a debug build make sure GT.M uses all of its debug options
-set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DDEBUG")
+if("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
+  set(GTM_BUILD_TYPE "pro")
+elseif("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
+  set(GTM_BUILD_TYPE "dbg")
+endif()
+
+# Enable GT.M debug options unless directed not to enable them. Added to build without whitebox tests.
+set(GTM_ENABLE_DEBUG 1 CACHE BOOL "Enable GT.M debug options")
+if(GTM_ENABLE_DEBUG)
+  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DDEBUG")
+endif()
 
 set(install_permissions_script
   OWNER_READ OWNER_EXECUTE OWNER_WRITE
@@ -57,8 +66,6 @@
 set(gt_src_list)
 set(sources_used "")
 set(extralibs "")
-set(is_encryption_supported 1)
-set(libmumpsrestoreregex "")
 message("--> OS = ${CMAKE_SYSTEM_NAME} / ARCH = ${CMAKE_SYSTEM_PROCESSOR}")
 # Establish platform
 # Except for Solaris, CMAKE_COMPILER_IS_GNUCC is true
@@ -86,6 +93,7 @@
 else()
   # Bootstrap using pre-generated bootstrap sources.
   # We generate them again only for comparison.
+  message(STATUS "Bootstraping from pre-generated sources.")
   set(gen_bootstrap 0)
   set(gen_bootstrap_dist "${GTM_BINARY_DIR}")
   set(gen_bootstrap_mumps "$<TARGET_FILE:mumps>")
@@ -119,14 +127,15 @@
 foreach(d ${gt_src_list})
   set(source_dir_${d} ${GTM_SOURCE_DIR}/${d})
   file(GLOB sources_${d} RELATIVE ${source_dir_${d}}
-	  ${d}/*.c ${d}/*.s ${d}/*.si)
+	  ${d}/*.c ${d}/*.s ${d}/*.si ${d}/*.txt)
 endforeach()
 if(gen_bootstrap)
   # Prefer generated sources over all other locations.
   set(gt_src_list gen ${gt_src_list})
   set(source_dir_gen ${GTM_BINARY_DIR}/gen)
   # Hard-code list since we cannot glob files that do not exist.
-  set(sources_gen cmerrors_ctl.c cmierrors_ctl.c gdeerrors_ctl.c merrors_ctl.c ttt.c)
+  set(sources_gen cmerrors_ctl.c cmierrors_ctl.c gdeerrors_ctl.c merrors_ctl.c ttt.c
+  		  gtmthreadgblasm.m gtm_threadgbl_deftypes.h gtm_threadgbl_deftypes_asm.si)
 endif()
 
 # The C preprocessor include search path consists of every source
@@ -168,11 +177,6 @@
 	set(src ${d}/${fname})
 	set("source_used_${fname}" 1)
 	list(APPEND sources_used ${source_dir_${d}}/${fname})
-	if(NOT "${libmumpsrestoreregex}" STREQUAL "")
-	  if(";${name};" MATCHES ";(${libmumpsrestoreregex});")
-	   set("source_used_${fname}" 0)
-          endif()
-        endif()
 	break()
       endif()
     endforeach()
@@ -203,9 +207,6 @@
 load_source_list(liblke          sr_unix/liblke.list)
 load_source_list(libmupip        sr_unix/libmupip.list)
 load_source_list(libstub         sr_unix/libstub.list)
-if("${CMAKE_SYSTEM_NAME}" STREQUAL "SunOS")
-  load_source_list(libgtmrpc	sr_sun/libgtmrpc.list)
-endif()
 
 # Assign sources to executables.
 set_source_list(gtm_threadgbl_deftypes gtm_threadgbl_deftypes)
@@ -220,16 +221,14 @@
 set_source_list(gtcm_shmclean    gtcm_shmclean)
 set_source_list(gtmsecshr        gtmsecshr_wrapper)
 set_source_list(gtmsecshr_real   gtmsecshr)
-set_source_list(libgtmcrypt      gtmcrypt_ref gtmcrypt_pk_ref gtmcrypt_dbk_ref)
+set_source_list(libgtmcrypt      gtmcrypt_ref gtmcrypt_pk_ref gtmcrypt_dbk_ref gtmcrypt_sym_ref gtmcrypt_util)
+set_source_list(libgtmtls        gtm_tls_impl gtmcrypt_util)
 set_source_list(libgtmshr        gtm_main)
 set_source_list(lke              lke lke_cmd)
-set_source_list(maskpass         maskpass)
+set_source_list(maskpass         maskpass gtmcrypt_util)
 set_source_list(mumps            gtm)
 set_source_list(mupip            mupip mupip_cmd)
 set_source_list(semstat2         semstat2)
-if("${CMAKE_SYSTEM_NAME}" STREQUAL "SunOS")
-  set_source_list(gtm_svc  	gtm_svc gtm_rpc_init gtm_dal_svc)
-endif()
 
 #-----------------------------------------------------------------------------
 # libmumps gets leftover sources, so compute the remaining list.
@@ -271,6 +270,7 @@
   WORKING_DIRECTORY ${GTM_BINARY_DIR}/gen
   COMMAND ${CMAKE_COMMAND}
     -D gtm_dist=${gen_bootstrap_dist}
+    -D gtm_tools=${GTM_SOURCE_DIR}/sr_port
     -D gtmroutines=.
     -D mumps=${gen_bootstrap_mumps}
     -D "args=${mumps_ttt_args}"
@@ -297,6 +297,7 @@
     WORKING_DIRECTORY ${GTM_BINARY_DIR}/gen
     COMMAND ${CMAKE_COMMAND}
       -D gtm_dist=${gen_bootstrap_dist}
+      -D gtm_tools=${GTM_SOURCE_DIR}/sr_port
       -D gtmroutines=.
       -D mumps=${gen_bootstrap_mumps}
       -D "args=${mumps_msg_args}"
@@ -331,10 +332,3 @@
     )
   add_custom_target(gen_xfer_desc DEPENDS xfer_desc.i)
   if(gen_bootstrap)
-    add_dependencies(gen_xfer_desc gen_bootstrap)
-  endif()
-endif()
-
-#-----------------------------------------------------------------------------
-
-add_executable(gtm_threadgbl_deftypes ${gtm_threadgbl_deftypes_SOURCES})
